/*************************************************
* ScalaSDL
*
*  /|/|
* (- - )
* (    )~
*
* RoNor
* ronor.u@gmail.com
* -----------------------------------------------
* SDL_structs.scala
* SDLで用意されている構造体をクラスに置き換えたものです。
*
* 参考資料
* http://www.libsdl.org/cgi/docwiki.cgi/SDL_API
*************************************************/

package sdl {
  class Version {
    var major:Int = 0
    var minor:Int = 0
    var patch:Int = 0
  }

  class Surface {
    var pointer:Int = 0
    var flags:Int = 0
    var format:PixelFormat = null
    var w:Int = 0
    var h:Int = 0
    var pitch:Int = 0
    var pixels:java.nio.ByteBuffer = null
    var clip_rect:Rect = null
    var refcount:Int = 0
  }

  class PixelFormat {
    var pointer:Int = 0
    var palette:Palette = null
    var BitsPerPixel:Int = 0
    var BytesPerPixel:Int = 0
    var Rloss:Int = 0
    var Gloss:Int = 0
    var Bloss:Int = 0
    var Aloss:Int = 0
    var Rshift:Int = 0
    var Gshift:Int = 0
    var Bshift:Int = 0
    var Ashift:Int = 0
    var Rmask:Int = 0
    var Gmask:Int = 0
    var Bmask:Int = 0
    var Amask:Int = 0
    var colorkey:Int = 0
    var alpha:Int = 0
  }

  class Palette {
    var pointer:Int = 0
    var ncolors:Int = 0
    var colors:Color = null
  }

  class Color {
    var r:Int = 0
    var g:Int = 0
    var b:Int = 0
    var unused:Int = 0
  }

  class Rect {
    var x:Int = 0
    var y:Int = 0
    var w:Int = 0
    var h:Int = 0
  }

  /**
  *This read-only structure is returned by SDL_GetVideoInfo.<br />
  *It contains information on either the best available mode if called before SDL_SetVideoMode or the current video mode if called after SDL_SetVideoMode.
  */
  class VideoInfo {
    var hw_available:Long = 1
    var wm_available:Long = 1
    var blit_hw:Long = 1
    var blit_hw_CC:Long = 1
    var blit_hw_A:Long = 1
    var blit_sw:Long = 1
    var blit_sw_CC:Long = 1
    var blit_sw_A:Long = 1
    var blit_fill:Long = 1
    var video_mem:Long = 0
    var vfmt:PixelFormat = null
    var current_w:Int = 0
    var current_h:Int = 0
  }

  class Overlay {
    var format:Int = 0
    var w:Int = 0
    var h:Int = 0
    var planes:Int = 0
    var pitches:Array[Int] = null
    var pixels:Array[Int] = null
    var hw_overlay:Int = 1
  }
}
